#pragma once

#include "MFCSensor.h"


class CMySensorEvents : public SensorAPI::CSensorEvents
{
public:
//Methods
  STDMETHOD(OnDataUpdated)(__RPC__in_opt ISensor* pSensor, __RPC__in_opt ISensorDataReport* /*pNewData*/);
};

class CMFCSensorAppDlg : public CDialog
{
public:
//Constructors / Destructors
  CMFCSensorAppDlg(_In_opt_ CWnd* pParent = nullptr);
  CMFCSensorAppDlg(const CMFCSensorAppDlg&) = delete;
  CMFCSensorAppDlg(CMFCSensorAppDlg&&) = delete;
  ~CMFCSensorAppDlg() = default; //NOLINT(modernize-use-override)

//Methods
  CMFCSensorAppDlg& operator=(const CMFCSensorAppDlg&) = delete;
  CMFCSensorAppDlg& operator=(CMFCSensorAppDlg&&) = delete;

protected:
//Methods
  BOOL OnInitDialog() override;

//Member variables
  enum { IDD = IDD_MFCSENSORAPP_DIALOG };
  HICON m_hIcon;
  SensorAPI::CSensor<CMySensorEvents> m_Sensor;

//Message handlers
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();

  DECLARE_MESSAGE_MAP()
};
